<template>
    <div class="modal fade" id="modalNewReservation" tabindex="-1" aria-labelledby="modalNewReservation" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h1 class="modal-title fs-5">Nova Reserva</h1>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close" id="btn-close-reservation"></button>
                </div>
                <div class="modal-body">
                    <div class="d-flex flex-column gap-3">
                        <div class="row">
                            <div class="col">
                                <label for="room" class="form-label">Quarto</label>
                                <select class="form-select" aria-label="room" v-model="form.room" @focus="listRooms">
                                    <option selected disabled :value="undefined">Selecione o quarto</option>
                                    <option v-for="room in availableRooms" :key="room" :value="room.id">{{ room.number }}</option>
                                </select>
                            </div>
                            <div class="col">
                                <label for="occupation" class="form-label">Ocupação</label>
                                <select class="form-select" aria-label="occupation" v-model="form.occupation">
                                    <option selected disabled :value="undefined">Selecione a ocupação</option>
                                    <option v-for="occupation in availableOccupation" :key="occupation" :value="occupation">{{ occupation }}</option>
                                </select>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col">
                                <label for="guest" class="form-label">Hóspede</label>
                                <input type="text" class="form-control"  aria-label="guest" placeholder="Nome do hóspede" v-model="form.guest">
                            </div>
                        </div>
                        <div class="row">
                            <div class="col">
                                <label for="checkin" class="form-label">Check-In</label>
                                <input type="date" class="form-control"  aria-label="checkin" :min="getTodayDay()" v-model="form.checkin">
                            </div>
                            <div class="col">
                                <label for="checkout" class="form-label">Check-Out</label>
                                <input type="date" class="form-control"  aria-label="checkout" :min="form.checkin" v-model="form.checkout">
                            </div>
                        </div>
                        <div class="row">
                            <h2>Adicionais:</h2>
                            <div class="col">
                                <div class="form-check">
                                    <input class="form-check-input" type="checkbox" v-model="form.breakfast">
                                    <label class="form-check-label">Café da Manhã</label>
                                </div>
                            </div>
                            <div class="col">
                                <div class="form-check">
                                    <input class="form-check-input" type="checkbox" v-model="garage">
                                    <label class="form-check-label">Garagem</label>
                                </div>
                                <input type="text" class="form-control" placeholder="Placa do veículo" v-if="garage" v-model="form.car">
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
                    <button type="button" class="btn btn-primary" @click="addReservation">Reservar</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import ServiceAPI from '@/services/ServiceAPI'
export default {
    name: 'ModalNewReservation',
    data: () => ({
        form: {
            room: undefined,
            occupation: undefined,
            guest: undefined,
            car: null,
            breakfast: false,
            checkin: undefined,
            checkout: undefined,
            status: undefined
        },
        garage: false,
        availableRooms: [],
        availableOccupation: 0
    }),
    watch: {
        'form.room': function() {
            if (this.form.room != undefined) {
                ServiceAPI.getRoomById(this.form.room)
                    .then((response) => {
                        this.availableOccupation = response.data[0].capacity
                    })
            }
        }
    },
    methods: {
        listRooms() {
            ServiceAPI.getAvailableRooms()
                .then((response) => {
                    this.availableRooms = response.data
                })
        },
        getTodayDay() {
            const data = new Date();
            const ano = data.getFullYear();
            const mes = (data.getMonth() + 1).toString().padStart(2, '0'); // O mês é baseado em zero, então adicionamos 1
            const dia = data.getDate().toString().padStart(2, '0');
            const dataFormatada = `${ano}-${mes}-${dia}`;
            return dataFormatada;
        },
        async addReservation() {
            await ServiceAPI.addReservation(this.form)
                .then(() => {
                    this.clearInputs()
                    this.$store.commit('setAlert', {
                        alert: true,
                        messageAlert: "Reserva realizada com sucesso",
                        error: false                        
                    })
                    this.close()
                }).finally(() => {
                    this.$store.commit('refreshInfos')
                })
        },
        clearInputs() {
            this.form = {
                room: undefined,
                occupation: undefined,
                guest: undefined,
                car: null,
                breakfast: false,
                checkin: undefined,
                checkout: undefined,
                status: undefined
            }
        },
        close() {
            console.log(document.getElementsByClassName("btn-close"))
            document.getElementById("btn-close-reservation").click()
        }
    }
}
</script>

<style scoped>
h2 {
    font-size: 1rem;
}
</style>
